Split code out into separate files and remove some global variables to
[rsync/rsync.git] / runtests.sh
index ab6f77a..d2865ae 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
+# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License version
@@ -125,6 +125,9 @@ set -e
 
 RUNSHFLAGS='-e'
 
+# for Solaris
+PATH="/usr/xpg4/bin/:$PATH"
+
 if [ -n "$loglevel" ] && [ "$loglevel" -gt 8 ]
 then
     if set -x
@@ -139,6 +142,20 @@ echo "$0 running in `pwd`"
 echo "    rsync_bin=$rsync_bin"
 echo "    srcdir=$srcdir"
 
+testuser=`whoami || echo UNKNOWN`
+
+echo "    testuser=$testuser"
+echo "    os=`uname -a`"
+
+# It must be "yes", not just nonnull
+if test "x$preserve_scratch" = xyes
+then
+    echo "    preserve_scratch=yes"
+else
+    echo "    preserve_scratch=no"
+fi    
+
+
 if test ! -f $rsync_bin
 then
     echo "rsync_bin $rsync_bin is not a file" >&2
@@ -160,16 +177,25 @@ missing=0
 passed=0
 failed=0
 
-scratchdir="`pwd`"/testtmp
-echo "    scratchdir=$scratchdir"
+# Prefix for scratch directory.  We create separate directories for
+# each test case, so that they can be left behind in case of failure
+# to aid investigation.
+scratchbase="`pwd`"/testtmp
+echo "    scratchbase=$scratchbase"
 
 suitedir="$srcdir/testsuite"
 
 export scratchdir suitedir
 
-clean_scratch() {
+prep_scratch() {
     [ -d "$scratchdir" ] && rm -rf "$scratchdir"
     mkdir "$scratchdir"
+    return 0
+}
+
+maybe_discard_scratch() {
+    [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+    return 0
 }
 
 if [ "x$whichtests" = x ]
@@ -179,32 +205,50 @@ fi
 
 for testscript in $suitedir/$whichtests
 do
-    testbase=`echo $testscript | sed 's!.*/!!'`
+    testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
+    scratchdir="$scratchbase.$testbase"
+
+    prep_scratch
 
-    echo "----- $testbase starting"
-    clean_scratch
+    set +e
+    sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
+    result=$?
+    set -e
 
-    if sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log"  2>&1
+    if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
     then
-       echo "----- $testbase completed successfully"
-       passed=`expr $passed + 1`
-    else 
-       case $? in
-       77)
-           echo "----- $testbase skipped"
-           skipped=`expr $skipped + 1`
-           ;;
-       *)
-           echo "----- $testbase failed: log follows"
-           cat "$scratchdir/test.log"
-           echo "----- $testbase log ends"
-           failed=`expr $failed + 1`
-           if [ "x$nopersist" = "xyes" ]
-           then
-               exit 1
-           fi
-       esac
+       echo "----- $testbase log follows"
+       cat "$scratchdir/test.log"
+       echo "----- $testbase log ends"
     fi
+
+    case $result in
+    0)
+       echo "PASS    $testbase"
+       passed=`expr $passed + 1`
+       maybe_discard_scratch
+       ;;
+    77)
+       # backticks will fill the whole file onto one line, which is a feature
+       echo "SKIP    $testbase (`cat \"$scratchdir/whyskipped\"`)"
+       skipped=`expr $skipped + 1`
+       maybe_discard_scratch
+       ;;
+    78)
+        # It failed, but we expected that.  don't dump out error logs, 
+       # because most users won't want to see them.  But do leave
+       # the working directory around.
+       echo "XFAIL   $testbase"
+       failed=`expr $failed + 1`
+       ;;
+    *)
+       echo "FAIL    $testbase"
+       failed=`expr $failed + 1`
+       if [ "x$nopersist" = "xyes" ]
+       then
+           exit 1
+       fi
+    esac
 done
 
 echo '------------------------------------------------------------'